# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`wsusserver`](#wsusserver)
* [`wsusserver::built_in_computer_target_groups`](#wsusserverbuilt_in_computer_target_groups)
* [`wsusserver::config`](#wsusserverconfig): Class: wsusserver::config
* [`wsusserver::install`](#wsusserverinstall): Class: wsusserver::install
* [`wsusserver::params`](#wsusserverparams): Class: wsusserver::params
* [`wsusserver::service`](#wsusserverservice): Class: wsusserver::service

### Defined types

* [`wsusserver::approvalrule`](#wsusserverapprovalrule): Define: wsusserver::approvalrule Parameters:

### Resource types

* [`wsusserver_computer_target_group`](#wsusserver_computer_target_group): Creates computer target groups for wsusserver.

## Classes

### <a name="wsusserver"></a>`wsusserver`

The wsusserver class.

#### Parameters

The following parameters are available in the `wsusserver` class:

* [`update_languages`](#update_languages)
* [`update_classifications`](#update_classifications)
* [`package_ensure`](#package_ensure)
* [`include_management_console`](#include_management_console)
* [`trigger_full_synchronization_post_install`](#trigger_full_synchronization_post_install)
* [`service_manage`](#service_manage)
* [`service_ensure`](#service_ensure)
* [`service_enable`](#service_enable)
* [`wsus_directory`](#wsus_directory)
* [`join_improvement_program`](#join_improvement_program)
* [`sync_from_microsoft_update`](#sync_from_microsoft_update)
* [`upstream_wsus_server_name`](#upstream_wsus_server_name)
* [`upstream_wsus_server_port`](#upstream_wsus_server_port)
* [`upstream_wsus_server_use_ssl`](#upstream_wsus_server_use_ssl)
* [`targeting_mode`](#targeting_mode)
* [`host_binaries_on_microsoft_update`](#host_binaries_on_microsoft_update)
* [`synchronize_automatically`](#synchronize_automatically)
* [`synchronize_time_of_day`](#synchronize_time_of_day)
* [`number_of_synchronizations_per_day`](#number_of_synchronizations_per_day)
* [`send_sync_notification`](#send_sync_notification)
* [`sync_notification_recipients`](#sync_notification_recipients)
* [`send_status_notification`](#send_status_notification)
* [`status_notification_recipients`](#status_notification_recipients)
* [`notification_frequency`](#notification_frequency)
* [`notification_time_of_day`](#notification_time_of_day)
* [`smtp_hostname`](#smtp_hostname)
* [`smtp_port`](#smtp_port)
* [`smtp_requires_authentication`](#smtp_requires_authentication)
* [`smtp_username`](#smtp_username)
* [`smtp_password`](#smtp_password)
* [`smtp_sender_displayname`](#smtp_sender_displayname)
* [`smtp_sender_emailaddress`](#smtp_sender_emailaddress)
* [`email_language`](#email_language)
* [`products`](#products)
* [`product_families`](#product_families)

##### <a name="update_languages"></a>`update_languages`

Data type: `Array[String, 1]`



##### <a name="update_classifications"></a>`update_classifications`

Data type: `Array[String, 1]`



##### <a name="package_ensure"></a>`package_ensure`

Data type: `Enum['present', 'absent']`



Default value: `$wsusserver::params::package_ensure`

##### <a name="include_management_console"></a>`include_management_console`

Data type: `Boolean`



Default value: `$wsusserver::params::include_management_console`

##### <a name="trigger_full_synchronization_post_install"></a>`trigger_full_synchronization_post_install`

Data type: `Boolean`



Default value: `$wsusserver::params::trigger_full_synchronization_post_install`

##### <a name="service_manage"></a>`service_manage`

Data type: `Boolean`



Default value: `$wsusserver::params::service_manage`

##### <a name="service_ensure"></a>`service_ensure`

Data type: `Enum['running', 'stopped']`



Default value: `$wsusserver::params::service_ensure`

##### <a name="service_enable"></a>`service_enable`

Data type: `Variant[ Boolean, Enum['manual'] ]`



Default value: `$wsusserver::params::service_enable`

##### <a name="wsus_directory"></a>`wsus_directory`

Data type: `Stdlib::Absolutepath`



Default value: `$wsusserver::params::wsus_directory`

##### <a name="join_improvement_program"></a>`join_improvement_program`

Data type: `Boolean`



Default value: `$wsusserver::params::join_improvement_program`

##### <a name="sync_from_microsoft_update"></a>`sync_from_microsoft_update`

Data type: `Boolean`



Default value: `$wsusserver::params::sync_from_microsoft_update`

##### <a name="upstream_wsus_server_name"></a>`upstream_wsus_server_name`

Data type: `Optional[String]`



Default value: `$wsusserver::params::upstream_wsus_server_name`

##### <a name="upstream_wsus_server_port"></a>`upstream_wsus_server_port`

Data type: `Integer`



Default value: `$wsusserver::params::upstream_wsus_server_port`

##### <a name="upstream_wsus_server_use_ssl"></a>`upstream_wsus_server_use_ssl`

Data type: `Boolean`



Default value: `$wsusserver::params::upstream_wsus_server_use_ssl`

##### <a name="targeting_mode"></a>`targeting_mode`

Data type: `Enum['Server', 'Client']`



Default value: `$wsusserver::params::targeting_mode`

##### <a name="host_binaries_on_microsoft_update"></a>`host_binaries_on_microsoft_update`

Data type: `Boolean`



Default value: `$wsusserver::params::host_binaries_on_microsoft_update`

##### <a name="synchronize_automatically"></a>`synchronize_automatically`

Data type: `Boolean`



Default value: `$wsusserver::params::synchronize_automatically`

##### <a name="synchronize_time_of_day"></a>`synchronize_time_of_day`

Data type: `String`



Default value: `$wsusserver::params::synchronize_time_of_day`

##### <a name="number_of_synchronizations_per_day"></a>`number_of_synchronizations_per_day`

Data type: `Integer`



Default value: `$wsusserver::params::number_of_synchronizations_per_day`

##### <a name="send_sync_notification"></a>`send_sync_notification`

Data type: `Boolean`



Default value: `$wsusserver::params::send_sync_notification`

##### <a name="sync_notification_recipients"></a>`sync_notification_recipients`

Data type: `Array[String, 1]`



Default value: `$wsusserver::params::sync_notification_recipients`

##### <a name="send_status_notification"></a>`send_status_notification`

Data type: `Boolean`



Default value: `$wsusserver::params::send_status_notification`

##### <a name="status_notification_recipients"></a>`status_notification_recipients`

Data type: `Array[String, 1]`



Default value: `$wsusserver::params::status_notification_recipients`

##### <a name="notification_frequency"></a>`notification_frequency`

Data type: `Enum['Weekly', 'Daily']`



Default value: `$wsusserver::params::notification_frequency`

##### <a name="notification_time_of_day"></a>`notification_time_of_day`

Data type: `String`



Default value: `$wsusserver::params::notification_time_of_day`

##### <a name="smtp_hostname"></a>`smtp_hostname`

Data type: `String`



Default value: `$wsusserver::params::smtp_hostname`

##### <a name="smtp_port"></a>`smtp_port`

Data type: `Integer`



Default value: `$wsusserver::params::smtp_port`

##### <a name="smtp_requires_authentication"></a>`smtp_requires_authentication`

Data type: `Boolean`



Default value: `$wsusserver::params::smtp_requires_authentication`

##### <a name="smtp_username"></a>`smtp_username`

Data type: `String`



Default value: `$wsusserver::params::smtp_username`

##### <a name="smtp_password"></a>`smtp_password`

Data type: `String`



Default value: `$wsusserver::params::smtp_password`

##### <a name="smtp_sender_displayname"></a>`smtp_sender_displayname`

Data type: `String`



Default value: `$wsusserver::params::smtp_sender_displayname`

##### <a name="smtp_sender_emailaddress"></a>`smtp_sender_emailaddress`

Data type: `String`



Default value: `$wsusserver::params::smtp_sender_emailaddress`

##### <a name="email_language"></a>`email_language`

Data type: `String`



Default value: `$wsusserver::params::email_language`

##### <a name="products"></a>`products`

Data type: `Variant[ Enum['*'], Array[String] ]`



Default value: `[]`

##### <a name="product_families"></a>`product_families`

Data type: `Array[String]`



Default value: `[]`

### <a name="wsusserverbuilt_in_computer_target_groups"></a>`wsusserver::built_in_computer_target_groups`

The wsusserver::built_in_computer_target_groups class.

### <a name="wsusserverconfig"></a>`wsusserver::config`

Class: wsusserver::config

#### Parameters

The following parameters are available in the `wsusserver::config` class:

* [`update_languages`](#update_languages)
* [`products`](#products)
* [`product_families`](#product_families)
* [`update_classifications`](#update_classifications)
* [`join_improvement_program`](#join_improvement_program)
* [`sync_from_microsoft_update`](#sync_from_microsoft_update)
* [`upstream_wsus_server_name`](#upstream_wsus_server_name)
* [`upstream_wsus_server_port`](#upstream_wsus_server_port)
* [`upstream_wsus_server_use_ssl`](#upstream_wsus_server_use_ssl)
* [`targeting_mode`](#targeting_mode)
* [`host_binaries_on_microsoft_update`](#host_binaries_on_microsoft_update)
* [`synchronize_automatically`](#synchronize_automatically)
* [`synchronize_time_of_day`](#synchronize_time_of_day)
* [`number_of_synchronizations_per_day`](#number_of_synchronizations_per_day)
* [`trigger_full_synchronization_post_install`](#trigger_full_synchronization_post_install)
* [`send_sync_notification`](#send_sync_notification)
* [`sync_notification_recipients`](#sync_notification_recipients)
* [`send_status_notification`](#send_status_notification)
* [`status_notification_recipients`](#status_notification_recipients)
* [`notification_frequency`](#notification_frequency)
* [`notification_time_of_day`](#notification_time_of_day)
* [`smtp_hostname`](#smtp_hostname)
* [`smtp_port`](#smtp_port)
* [`smtp_requires_authentication`](#smtp_requires_authentication)
* [`smtp_username`](#smtp_username)
* [`smtp_password`](#smtp_password)
* [`smtp_sender_displayname`](#smtp_sender_displayname)
* [`smtp_sender_emailaddress`](#smtp_sender_emailaddress)
* [`email_language`](#email_language)

##### <a name="update_languages"></a>`update_languages`

Data type: `Array[String, 1]`



##### <a name="products"></a>`products`

Data type: `Array[String, 0]`



##### <a name="product_families"></a>`product_families`

Data type: `Optional[Array[String]]`



##### <a name="update_classifications"></a>`update_classifications`

Data type: `Array[String, 1]`



##### <a name="join_improvement_program"></a>`join_improvement_program`

Data type: `Boolean`



Default value: `$wsusserver::params::join_improvement_program`

##### <a name="sync_from_microsoft_update"></a>`sync_from_microsoft_update`

Data type: `Boolean`



Default value: `$wsusserver::params::sync_from_microsoft_update`

##### <a name="upstream_wsus_server_name"></a>`upstream_wsus_server_name`

Data type: `Optional[String]`



Default value: `$wsusserver::params::upstream_wsus_server_name`

##### <a name="upstream_wsus_server_port"></a>`upstream_wsus_server_port`

Data type: `Integer`



Default value: `$wsusserver::params::upstream_wsus_server_port`

##### <a name="upstream_wsus_server_use_ssl"></a>`upstream_wsus_server_use_ssl`

Data type: `Boolean`



Default value: `$wsusserver::params::upstream_wsus_server_use_ssl`

##### <a name="targeting_mode"></a>`targeting_mode`

Data type: `Enum['Server', 'Client']`



Default value: `$wsusserver::params::targeting_mode`

##### <a name="host_binaries_on_microsoft_update"></a>`host_binaries_on_microsoft_update`

Data type: `Boolean`



Default value: `$wsusserver::params::host_binaries_on_microsoft_update`

##### <a name="synchronize_automatically"></a>`synchronize_automatically`

Data type: `Boolean`



Default value: `$wsusserver::params::synchronize_automatically`

##### <a name="synchronize_time_of_day"></a>`synchronize_time_of_day`

Data type: `String`



Default value: `$wsusserver::params::synchronize_time_of_day`

##### <a name="number_of_synchronizations_per_day"></a>`number_of_synchronizations_per_day`

Data type: `Integer`



Default value: `$wsusserver::params::number_of_synchronizations_per_day`

##### <a name="trigger_full_synchronization_post_install"></a>`trigger_full_synchronization_post_install`

Data type: `Boolean`



Default value: `$wsusserver::params::trigger_full_synchronization_post_install`

##### <a name="send_sync_notification"></a>`send_sync_notification`

Data type: `Boolean`



Default value: `$wsusserver::params::send_sync_notification`

##### <a name="sync_notification_recipients"></a>`sync_notification_recipients`

Data type: `Array[String, 1]`



Default value: `$wsusserver::params::sync_notification_recipients`

##### <a name="send_status_notification"></a>`send_status_notification`

Data type: `Boolean`



Default value: `$wsusserver::params::send_status_notification`

##### <a name="status_notification_recipients"></a>`status_notification_recipients`

Data type: `Array[String, 1]`



Default value: `$wsusserver::params::status_notification_recipients`

##### <a name="notification_frequency"></a>`notification_frequency`

Data type: `Enum['Weekly', 'Daily']`



Default value: `$wsusserver::params::notification_frequency`

##### <a name="notification_time_of_day"></a>`notification_time_of_day`

Data type: `String`



Default value: `$wsusserver::params::notification_time_of_day`

##### <a name="smtp_hostname"></a>`smtp_hostname`

Data type: `String`



Default value: `$wsusserver::params::smtp_hostname`

##### <a name="smtp_port"></a>`smtp_port`

Data type: `Integer`



Default value: `$wsusserver::params::smtp_port`

##### <a name="smtp_requires_authentication"></a>`smtp_requires_authentication`

Data type: `Boolean`



Default value: `$wsusserver::params::smtp_requires_authentication`

##### <a name="smtp_username"></a>`smtp_username`

Data type: `String`



Default value: `$wsusserver::params::smtp_username`

##### <a name="smtp_password"></a>`smtp_password`

Data type: `String`



Default value: `$wsusserver::params::smtp_password`

##### <a name="smtp_sender_displayname"></a>`smtp_sender_displayname`

Data type: `String`



Default value: `$wsusserver::params::smtp_sender_displayname`

##### <a name="smtp_sender_emailaddress"></a>`smtp_sender_emailaddress`

Data type: `String`



Default value: `$wsusserver::params::smtp_sender_emailaddress`

##### <a name="email_language"></a>`email_language`

Data type: `String`



Default value: `$wsusserver::params::email_language`

### <a name="wsusserverinstall"></a>`wsusserver::install`

Class: wsusserver::install

#### Parameters

The following parameters are available in the `wsusserver::install` class:

* [`package_ensure`](#package_ensure)
* [`include_management_console`](#include_management_console)
* [`wsus_directory`](#wsus_directory)
* [`join_improvement_program`](#join_improvement_program)

##### <a name="package_ensure"></a>`package_ensure`

Data type: `Enum['present', 'absent']`



Default value: `$wsusserver::params::package_ensure`

##### <a name="include_management_console"></a>`include_management_console`

Data type: `Boolean`



Default value: `$wsusserver::params::include_management_console`

##### <a name="wsus_directory"></a>`wsus_directory`

Data type: `Stdlib::Absolutepath`



Default value: `$wsusserver::params::wsus_directory`

##### <a name="join_improvement_program"></a>`join_improvement_program`

Data type: `Boolean`



Default value: `$wsusserver::params::join_improvement_program`

### <a name="wsusserverparams"></a>`wsusserver::params`

Class: wsusserver::params

### <a name="wsusserverservice"></a>`wsusserver::service`

Class: wsusserver::service

#### Parameters

The following parameters are available in the `wsusserver::service` class:

* [`service_manage`](#service_manage)
* [`service_ensure`](#service_ensure)
* [`service_enable`](#service_enable)

##### <a name="service_manage"></a>`service_manage`

Data type: `Boolean`



Default value: `$wsusserver::params::service_manage`

##### <a name="service_ensure"></a>`service_ensure`

Data type: `Enum['running', 'stopped']`



Default value: `$wsusserver::params::service_ensure`

##### <a name="service_enable"></a>`service_enable`

Data type: `Variant[ Boolean, Enum['manual'] ]`



Default value: `$wsusserver::params::service_enable`

## Defined types

### <a name="wsusserverapprovalrule"></a>`wsusserver::approvalrule`

Define: wsusserver::approvalrule
Parameters:

#### Parameters

The following parameters are available in the `wsusserver::approvalrule` defined type:

* [`classifications`](#classifications)
* [`products`](#products)
* [`computer_groups`](#computer_groups)
* [`rule_name`](#rule_name)
* [`ensure`](#ensure)
* [`enabled`](#enabled)

##### <a name="classifications"></a>`classifications`

Data type: `Array[String]`



##### <a name="products"></a>`products`

Data type: `Array[String]`



##### <a name="computer_groups"></a>`computer_groups`

Data type: `Array[String]`



##### <a name="rule_name"></a>`rule_name`

Data type: `String`



Default value: `$title`

##### <a name="ensure"></a>`ensure`

Data type: `Enum['present', 'absent']`



Default value: `'present'`

##### <a name="enabled"></a>`enabled`

Data type: `Boolean`



Default value: ``true``

## Resource types

### <a name="wsusserver_computer_target_group"></a>`wsusserver_computer_target_group`

Creates computer target groups for wsusserver.

#### Properties

The following properties are available in the `wsusserver_computer_target_group` type.

##### `ensure`

Valid values: `present`, `absent`

Specifies whether the computer target group should be present or absent.

Default value: `present`

##### `id`

The auto-generated id of the computer target group. This property is read-only.

#### Parameters

The following parameters are available in the `wsusserver_computer_target_group` type.

* [`name`](#name)
* [`provider`](#provider)

##### <a name="name"></a>`name`

namevar

The name of the computer target group.

##### <a name="provider"></a>`provider`

The specific backend to use for this `wsusserver_computer_target_group` resource. You will seldom need to specify this
--- Puppet will usually discover the appropriate provider for your platform.

